// helprcDlg.cpp : implementation file
//

#include "stdafx.h"
#include "helprc.h"
#include "helprcDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelprcDlg dialog

CHelprcDlg::CHelprcDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHelprcDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHelprcDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHelprcDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHelprcDlg)
	DDX_Control(pDX, IDC_MENU_LIST, m_cMenuList);
	DDX_Control(pDX, IDC_DIALOG_LIST, m_cDialogList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHelprcDlg, CDialog)
	//{{AFX_MSG_MAP(CHelprcDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_BN_CLICKED(IDC_WRITE_DLG, OnWriteDlg)
	ON_BN_CLICKED(IDC_WRITE_MENU, OnWriteMenu)
	ON_BN_CLICKED(IDC_MENU_TAB, OnMenuTab)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHelprcDlg message handlers

BOOL CHelprcDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_cMenuList.SetTabStops(175);	
	m_cDialogList.SetTabStops(175);	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHelprcDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CHelprcDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHelprcDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHelprcDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHelprcDlg::OnOpen() 
{
	int i;
	CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY,
		"resource (*.rc)|*.rc||");
	if (dlg.DoModal()!=IDOK)
		return;
	m_FileName=dlg.GetPathName();
	CStdioFile file;
	if (!file.Open(m_FileName,CFile::modeRead|CFile::typeText|CFile::shareDenyWrite))
	{
		AfxMessageBox("Couldn't open RC file");
		return;
	}
	
	if (!m_DialogMap.IsEmpty())
		m_DialogMap.RemoveAll();
	if (!m_MenuMap.IsEmpty())
		m_MenuMap.RemoveAll();
	if (!m_StringMap.IsEmpty())
		m_StringMap.RemoveAll();
	m_cMenuList.ResetContent();
	m_cDialogList.ResetContent();

	CString str,str2,ID,Caption,mapStr;
	while (file.ReadString(str))
	{

		if (str.Find("#ifdef APSTUDIO_INVOKED")>-1)	// skip design details
		{
			while (1)
			{
				VERIFY(file.ReadString(str));
				if (str.Find("#endif    // APSTUDIO_INVOKED")>-1)
					break;
			}
		}

// do STRINGTABLE
		if (str.Left(12)=="STRINGTABLE ")
		{
			file.ReadString(str);
			ASSERT(str.Find("BEGIN")>-1);
			while (1)
			{
				file.ReadString(str);
				if (str.Find("END")>-1)
					break;
				str.TrimLeft();	// drop leading whitespace
				i=str.Find(' ');
				ID=str.Left(i);
				i=str.Find('"');
				str2=str.Right(str.GetLength()-(i+1));
				i=str2.Find('"');
				Caption=str2.Left(i);
				m_StringMap.SetAt(ID,Caption);
TRACE("ID = %s, caption = %s\n",ID,Caption);
			}
		}

// look for dialog
		if (str.Find("DIALOG ")>-1)	// got possible dialog resource
		{
			i=str.Find(' ');
			ID=str.Left(i);
			ASSERT(ID.Left(3)=="IDD"||ID.Left(3)=="IDR");
			// look for caption
			Caption="No title";
			while (1)
			{
				VERIFY(file.ReadString(str));
				if (str.Left(8)=="CAPTION ")	// got caption
				{
					str2=str.Right(str.GetLength()-9);	// loose CAPTION "
					Caption=str2.Left(str2.GetLength()-1);	// loose last "
				}
				if (str.GetLength()==0)		// end of resource section
					break;
			}
//TRACE("ID = %s, caption = %s\n",ID,Caption);
			m_DialogMap.SetAt(ID,Caption);
		}

// look for menu
		if (str.Find("MENUITEM \"")>-1)
		{
			i=str.Find('"');
			str2=str.Right(str.GetLength()-(i+1));
			i=str2.Find('"');
			Caption=str2.Left(i);
			i=str.ReverseFind(' ');
			VERIFY(i>-1);
			ID=str.Right(str.GetLength()-(i+1));
//TRACE("ID = %s, caption = %s\n",ID,Caption);
			m_MenuMap.SetAt(ID,Caption);
		}
	}
	file.Close();

	POSITION pos;
	pos=m_DialogMap.GetStartPosition();
	while (pos!=NULL)
	{
		m_DialogMap.GetNextAssoc(pos,ID,Caption);
		str=ID+"\t"+Caption;
		m_cDialogList.AddString(str);
TRACE("ID = %s, caption = %s\n",ID,Caption);
	}
	pos=m_MenuMap.GetStartPosition();
	while (pos!=NULL)
	{
		m_MenuMap.GetNextAssoc(pos,ID,Caption);
		str=ID+"\t"+Caption;
		m_cMenuList.AddString(str);
TRACE("ID = %s, caption = %s\n",ID,Caption);
	}
	GetDlgItem(IDC_WRITE_DLG)->EnableWindow(TRUE);
	GetDlgItem(IDC_WRITE_MENU)->EnableWindow(TRUE);
	GetDlgItem(IDC_MENU_TAB)->EnableWindow(TRUE);
}

void CHelprcDlg::OnWriteDlg() 
{
	
	DoWrite(&m_DialogMap,&m_cDialogList,0);
}

void CHelprcDlg::OnWriteMenu() 
{
	DoWrite(&m_MenuMap,&m_cMenuList,1);
}

void CHelprcDlg::DoWrite(CMapStringToString *pMap,CListBox *pList,int type)
{
// type==0 = Dialog, ==1 =menu
	int i,j;
	CFileDialog dlg(FALSE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"help file (*.rtf)|*.rtf||");
	dlg.m_ofn.lpstrDefExt="rtf";
	if (dlg.DoModal()!=IDOK)
		return;
	CStdioFile file;
	if (!file.Open(dlg.GetPathName(),CFile::modeCreate|CFile::modeWrite|CFile::typeText|CFile::shareDenyWrite))
	{
		AfxMessageBox("Couldn't open RTF file");
		return;
	}
	CString str,ID,Caption;

// write RTF header
	str="{\\rtf1\\ansi\\ansicpg1252\\uc1 \\deff0{\\fonttbl{\\f1\\fswiss\\fcharset0\\fprq2{\\*\\panose 020b0604020202020204}Arial;}}";
	str+="\n";
	file.WriteString(str);
	str="\\widowctrl\\ftnbj\\aenddoc\\noxlattoyen\\expshrtn\\noultrlspc\\dntblnsbdb\\nospaceforul\\hyphcaps0\\formshade\\horzdoc\\dgmargin\\dghspace180\\dgvspace180\\dghorigin1800\\dgvorigin1440\\dghshow1\\dgvshow1";
	str+="\n";
	file.WriteString(str);
	str="\\pard\\plain ";
	str+="\n";
	file.WriteString(str);

	for (i=0; i<pList->GetCount(); i++)
	{
		pList->GetText(i,str);
		j=str.Find('\t');
		ID=str.Left(j);
		pMap->Lookup(ID,Caption);
// write footnotes
		file.WriteString("{\\super ${\\footnote {\\super $}{ \n");
		if (type==0)
			file.WriteString(Caption+" dialog\n");	// title
		else if (type==1)
			file.WriteString(Caption+" command\n");	// title
		file.WriteString("}}K{\\footnote {\\super K}{ \n");
		file.WriteString(Caption+"\n");	// keyword
		file.WriteString("}}#{\\footnote {\\super #}{ \n");
		file.WriteString("H"+ID);	// ID
		file.WriteString("}}}\n");

// write first line of text, newline, newpage
		file.WriteString("{\\b\\f1\\fs24 "+Caption+"\\par}\n{\\f1\\fs20 \\par \\page }\n");
	}
	file.WriteString("}\n");
	file.Close();
}

void CHelprcDlg::OnMenuTab() 
{
	int i,j;

	CStdioFile fileSrc,file;
	CString ln,resID,menuTitle,str,str2,ID,Caption,Desc;

	if (!fileSrc.Open(m_FileName,CFile::modeRead|CFile::typeText|CFile::shareDenyWrite))
	{
		AfxMessageBox("Couldn't open RC file");
		return;
	}

	
	CFileDialog dlg(FALSE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"help file (*.rtf)|*.rtf||");
	dlg.m_ofn.lpstrDefExt="rtf";
	if (dlg.DoModal()!=IDOK)
		return;
	if (!file.Open(dlg.GetPathName(),CFile::modeCreate|CFile::modeWrite|CFile::typeText|CFile::shareDenyWrite))
	{
		AfxMessageBox("Couldn't open RTF file");
		return;
	}

// write header section of RTF file
	str="{\\rtf1\\ansi\\ansicpg1252\\uc1 \\deff0{\\fonttbl{\\f1\\fswiss\\fcharset0\\fprq2{\\*\\panose 020b0604020202020204}Arial;}}";
	str+="\n";
	file.WriteString(str);
	str="\\widowctrl\\ftnbj\\aenddoc\\noxlattoyen\\expshrtn\\noultrlspc\\dntblnsbdb\\nospaceforul\\hyphcaps0\\formshade\\horzdoc\\dgmargin\\dghspace180\\dgvspace180\\dghorigin1800\\dgvorigin1440\\dghshow1\\dgvshow1";
	str+="\n";
	file.WriteString(str);
	str="\\pard\\plain ";
	str+="\n";
	file.WriteString(str);

	int inPopup=0;
	CStringArray CapArray;
	int xxx=0;
	while (fileSrc.ReadString(ln))
	{
// look for menu
		if (ln.Find(" MENU ")>-1)	// got menu resource
		{
			i=ln.Find(' ');
			resID=ln.Left(i);	// get IDR_...
TRACE("menu resource %s\n",resID);
			if (resID=="IDR_RESULTSNEURON_TMPL")
				xxx=TRUE;
			fileSrc.ReadString(ln);
			ASSERT(ln=="BEGIN");
			while (1)	// look for end of this menu resource
			{
				ASSERT(inPopup==0);
				fileSrc.ReadString(ln);
				if (ln.Find("END")>-1)
				{
					break;
				}
				if (ln.Find("POPUP")==-1)	// look for popup, can get separators on menu bar
					continue;
				inPopup++;		// inPopup==1
				i=ln.Find('"');
				str=ln.Right(ln.GetLength()-(i+1));
				menuTitle=str.SpanExcluding("\"");

// starting new page
// footnotes
				file.WriteString("{\\super ${\\footnote {\\super $}{ \n");
				file.WriteString(menuTitle+" menu commands");
				file.WriteString("}}K{\\footnote {\\super K}{ \n");
				file.WriteString(menuTitle+" menu");
				file.WriteString("}}#{\\footnote {\\super #}{ \n");
				file.WriteString("menu_"+menuTitle);
				file.WriteString("}}}\n");

// title line
				str=menuTitle;
				str+=" menu commands";
				file.WriteString("{\\b\\f1\\fs24 "+str+"\\par}\n{\\f1\\fs20 \\par }\n");

// first line of body text page
				file.WriteString("\\f1 The "+menuTitle+" menu offers the following commands:\\par "+resID+"\\par \n");
				
TRACE("popup menu %s\n",menuTitle);
				fileSrc.ReadString(ln);
				CapArray.RemoveAll();	// in case got stuff from previous menu
				ASSERT(ln.Find("BEGIN")>-1);
				while (1)	// look for end of this menu drop-down, might have popups within
				{
					fileSrc.ReadString(ln);
					if (ln.Find("POPUP")>-1)	// got sub popup
					{
						inPopup++;		// inPopup ==2 if 1st sub,
						i=ln.Find('"');
						str=ln.Right(ln.GetLength()-(i+1));
						str2.Empty();
						for (j=inPopup; j>2; j--)	// if 2nd sub or less, add in previous subs
							str2+=CapArray.GetAt(j-3);
						str2+=str.SpanExcluding("\"");
						str2+=": ";
						CapArray.Add(str2);
						continue;
					}
					if (ln.Find("END")>-1)
					{
						inPopup--;
						if (inPopup>=1)
							CapArray.RemoveAt(inPopup-1);
						if (inPopup==0)
						{
// finish off table, Should put in new page
							file.WriteString("\\pard \\ql \\li0\\ri0\\widctlpar\\aspalpha\\aspnum\\faauto\\adjustright\\rin0\\lin0\\itap0 \n");
							file.WriteString("{\\par \\page }\n");
							break;
						}
					}
					if (ln.Find("MENUITEM ")==-1)	// begin??
						continue;
					if (ln.Find("SEPARATOR")>-1)
						continue;
// now in menuItem with data
					i=ln.Find('"');
					str=ln.Right(ln.GetLength()-(i+1));
					Caption.Empty();
					if (inPopup>1)
						Caption=CapArray.GetAt(inPopup-2);
					Caption+=str.SpanExcluding("\"");
					i=ln.ReverseFind(' ');
					VERIFY(i>-1);
					ID=ln.Right(ln.GetLength()-(i+1));

					if (!m_StringMap.Lookup(ID,Desc))
						Desc="good stuff here";
TRACE("menu item %s, ID %s\n",Caption,ID);

// write table row
					file.WriteString("\\trowd \\intbl{\\f1\\uldb \n");
					file.WriteString(Caption+"\n");
					file.WriteString("}{\\v\\f1 \n");
					file.WriteString("H"+ID+"\n");
					file.WriteString("}{\\f1 \\par }{\\f1\\uldb \\cell }{\\f1 \n");
					file.WriteString(Desc+"\n");
					file.WriteString("\\cell }\\intbl\n");
					file.WriteString("{\\f1 \\trowd \\trgaph108\\trleft-108\\trftsWidth3\\trwWidth8730\\trftsWidthB3\n");
					file.WriteString("\\trpaddl108\\trpaddr108\\trpaddfl3\\trpaddfr3 \n");
					file.WriteString("\\clvertalt\\cltxlrtb\\clftsWidth3\\clwWidth1818 \\cellx1710\\clvertalt\\clbrdrt\n");
					file.WriteString("\\cltxlrtb\\clftsWidth3\\clwWidth6912 \\cellx8622\\row }\n");
				
				}
			}

		}
	}

	file.WriteString("}\n");
	file.Close();
	fileSrc.Close();
}
